Bluetooth audio to A2DP headset no longer works following upgrade from 4.12 to 4.13 in artful

Bug #1719210 reported by Max Bowsher on 2017-09-24
50
This bug affects 10 people
Affects Status Importance Assigned to Milestone
linux (Ubuntu)
Medium
Unassigned
linux-firmware (Ubuntu)
Undecided
Unassigned

Bug Description

Using artful kernel 4.12.0-13.14, Bluetooth audio works great.

Upgrading to artful kernel 4.13.0-11.12, there are severe Bluetooth audio issues which have manifested in a variety of weird ways:

1) Playback would stall after 10-20 seconds
2) Upon removing the device and attempting to redo pairing, no devices could be found to pair with
3) After the device ended up reverting to low quality mono HSP mode, it could not be switched back to A2DP

This is all rather vague - sorry - but it felt better to get notice of this regression into the bugtracker sooner rather than later.

ProblemType: Bug
DistroRelease: Ubuntu 17.10
Package: linux-image-4.13.0-11-generic 4.13.0-11.12
ProcVersionSignature: Ubuntu 4.13.0-11.12-generic 4.13.1
Uname: Linux 4.13.0-11-generic x86_64
ApportVersion: 2.20.7-0ubuntu1
Architecture: amd64
AudioDevicesInUse:
 USER PID ACCESS COMMAND
 /dev/snd/controlC0: maxb 2091 F.... pulseaudio
CurrentDesktop: ubuntu:GNOME
Date: Sun Sep 24 21:24:00 2017
EcryptfsInUse: Yes
HibernationDevice: RESUME=UUID=635db8ca-b352-4622-87eb-08f74460324b
InstallationDate: Installed on 2016-08-16 (404 days ago)
InstallationMedia: Ubuntu 16.04.1 LTS "Xenial Xerus" - Release amd64 (20160719)
MachineType: HP HP Spectre Notebook
ProcFB: 0 inteldrmfb
ProcKernelCmdLine: BOOT_IMAGE=/boot/vmlinuz-4.13.0-11-generic root=UUID=4989886a-f95e-4802-ab51-dcbf53167aeb ro quiet splash vt.handoff=7
RelatedPackageVersions:
 linux-restricted-modules-4.13.0-11-generic N/A
 linux-backports-modules-4.13.0-11-generic N/A
 linux-firmware 1.168
SourcePackage: linux
UpgradeStatus: Upgraded to artful on 2017-08-31 (23 days ago)
dmi.bios.date: 02/21/2017
dmi.bios.vendor: Insyde
dmi.bios.version: F.31
dmi.board.asset.tag: Type2 - Board Asset Tag
dmi.board.name: 81A0
dmi.board.vendor: HP
dmi.board.version: 48.54
dmi.chassis.type: 10
dmi.chassis.vendor: HP
dmi.chassis.version: Chassis Version
dmi.modalias: dmi:bvnInsyde:bvrF.31:bd02/21/2017:svnHP:pnHPSpectreNotebook:pvrType1ProductConfigId:rvnHP:rn81A0:rvr48.54:cvnHP:ct10:cvrChassisVersion:
dmi.product.family: 103C_5335KV G=N L=CON B=HP S=SPT
dmi.product.name: HP Spectre Notebook
dmi.product.version: Type1ProductConfigId
dmi.sys.vendor: HP

Max Bowsher (maxb) wrote :

This change was made by a bot.

Changed in linux (Ubuntu):
status: New → Confirmed
Max Bowsher (maxb) wrote :

Lack of functionality also a problem in mainline-ppa 4.13.3 version. The following messages are logged to the journal:

Sep 24 21:44:05 spectre bluetoothd[826]: Unable to get Headset Voice gateway SDP record: Connection timed out
Sep 24 21:44:46 spectre bluetoothd[826]: connect error: Connection refused (111)

Max Bowsher (maxb) wrote :

Mainline ppa 4.12.14 is working OK

Barry Price (barryprice) wrote :

Seeing similar issues with a Logitech M337 bluetooth mouse under the new 4.13.0-11 kernel.

Reverting to 4.12.0-13 solves the problem.

Kai-Heng Feng (kaihengfeng) wrote :

Does this also happen to 4.14-rc1?

Changed in linux (Ubuntu):
importance: Undecided → Medium
status: Confirmed → Incomplete
tags: added: needs-bisect
Max Bowsher (maxb) wrote :

I am seriously confused.

As requested, I tested out a 4.14-rc - actually, I tested -rc2 since that had come out - and the problem was present - audio playback would freeze after around 40-50 seconds.

Then I went back to various 4.13 versions and attempted to get the start of a bisection going - but I've been *unable to reproduce* the problem with the same 4.13 versions that I initially filed the bug about.

It seems that I'm going to have to run 4.13 for a while, and try to figure out a reliable reproduction recipe.

Yet, despite that, it seems that something is further wrong in 4.14 since it's reliably breaking there :-/

Slomo (slomo17) wrote :

I have the same problem with similar symptoms, headset connects and works, after some time, the video stops and the headset stops working, than i can't connect again, have to remove the device, reboot, turn of and on the headphones to get it working again. But the problems doesn't always occur, somtines they work normaly. I never testet ubuntu with kernel 4.12 maybe i should do that

This appears to be a problem with either the kernel or the firmware for intel wifi/bluetooth chipsets. I've found that adding the following to /etc/modprobe.d/iwlwifi.conf and then rebooting seems to solve my problems:

options bt_coex_active=0

I've got no idea where this radio conflict is coming from as it was fine in earlier kernels :(

Max Bowsher (maxb) wrote :

Hmm... empirically, I seem to have discovered a factor related to why this sometimes works and sometimes does not with 4.13 - for me, the bug only occurs if my laptop is booted *without* AC power applied.

Which makes no sense. But seems to be happening anyway.

Max Bowsher (maxb) wrote :

Or so I thought :-( I got set up for bisecting again, and now I can't reproduce the problem at all.

Max Bowsher (maxb) wrote :

OK, I think I finally found the real trigger, helped by John Tanner's comment and Googling the bt_coex_active option. It's trying to simultaneously use bluetooth and a *2.4GHz* wifi network.

Trying that on my hardware results in lots of iwlwifi kernel logging reporting that the device microcode keeps crashing and requiring a hardware reset.

This happens both on 4.12 and 4.13, but 4.12 doesn't let it disrupt the bluetooth audio stream, so I didn't notice, but 4.13 kills the bluetooth connection.

Peter Rhone (prhone-gmail) wrote :

@ Kai-Heng Feng (kaihengfeng) https://bugs.launchpad.net/ubuntu/+source/linux/+bug/1719210/comments/6

Since my bug has been marked as a duplicate of this one, I'll respond to your comment here.
Yes, the bug exists for me all kernels > 4.12, up to and including 4.14-rc3.
I can no longer use my Sony Bluetooth Speaker SRS-XB40.

@Bowsher's hack of putting
options bt_coex_active=0
in /etc/modprobe.d/iwlwifi.conf
is no solution, since I need both BT and WiFi.

Peter Rhone (prhone-gmail) wrote :

The latest linux-firmware update today, running the stock kernel 4.13.0-12-generic has fixed the problem for me (connecting to Sony SRS-XB40 speaker).

Guillaume Martres (smarter) wrote :

Same issue here on a Thinkpad P50, although I don't see any iwlwifi crash in the logs. Going back to the 4.10 kernel from Zesty fixes the problem.

Slomo (slomo17) wrote :

After a few days of testing i can say using kernel 4.12 works for me, but options bt_coex_active=0 doesn't. Also the new linux-firmware update didn't fixed it.

Max Bowsher (maxb) wrote :

Confirming this is very much *not* fixed - the last linux-firmware upload doesn't seem to have touched anything iwlwifi-related at all: https://launchpadlibrarian.net/339888041/linux-firmware_1.168_1.169.diff.gz

Max Bowsher (maxb) wrote :

I also seem to now be having Bluetooth-unrelated issues with iwlwifi, filed in bug 1722109

Peter Rhone (prhone-gmail) wrote :

I have to correct my earlier statement (comment 14), the linux-firmware package update didn't fix the problem after all - it seemed to work for a while, but I was mistaken. Now, however, I've gotten it working. The correct fix is to add the following line to the end of /etc/modprobe.d/iwlwifi.conf

options iwlwifi bt_coex_active=0

After a reboot, you can test if the option is enabled with

cat /sys/module/iwlwifi/parameters/bt_coex_active

(Should return 'N').

Since I added that option, I haven't had any further issues with my Sony Bluetooth Speaker (or WiFi).

Slomo (slomo17) wrote :

i also have to correct my statement
"options iwlwifi bt_coex_active=0" and Kernel 4.13 works for me, but with 4.14 i still got wifi problems, but it's sill an RC and not default in 17.10

Slomo (slomo17) wrote :

After some testing, i experience a audio delay, when using bluetooth headset when using "options iwlwifi bt_coex_active=0", which doesn't happen with kernel 4.12

Following response #4, I did:

git clone git://github.com/GM-Script-Writer-62850/Ubuntu-Mainline-Kernel-Updater
cd Ubuntu-Mainline-Kernel-Updater/
sudo bash install
KernelUpdateChecker -ar -v 4.12 -f
sudo /tmp/kernel-update

Then in the install process deleted the 4.13 kernel, and now bluetooth is running fine.

Max Bowsher (maxb) wrote :

The exact manifestation of this seems to have changed (now the gnome settings UI claims that my hardware doesn't have bluetooth support at all - despite CLI bluetoothctl still being aware of it) but the basic issue still very much remains: 4.13 from artful => bluetooth inoperable; 4.10 from zesty => works fine.

Max Bowsher (maxb) wrote :

Adding linux-firmware as an affected package - on further investigation, it turns out that the real problem here appears to be firmware incompatibility between the Wifi and Bluetooth parts of the 8260 package.

Relevant bug in Kernel bugzilla: https://bugzilla.kernel.org/show_bug.cgi?id=197807

Relevant commit delivering updated firmware to upstream linux-firmware.git repository fixing the issue: https://git.kernel.org/pub/scm/linux/kernel/git/firmware/linux-firmware.git/commit?id=fdee922a785212be7ccced6809b337290fdac971

Ideally that would be SRUed into artful.

Launchpad Janitor (janitor) wrote :

Status changed to 'Confirmed' because the bug affects multiple users.

Changed in linux-firmware (Ubuntu):
status: New → Confirmed
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Duplicates of this bug

Other bug subscribers

Remote bug watches

Bug watches keep track of this bug in other bug trackers.